## openmolcas 21.10

=== CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2014-2016, Steven Vancoillie                           *
#               2014-2021, Ignacio Fdez. Galván                        *
#               2015, Stefan Knecht                                    *
#               2020, Gerardo Raggi                                    *
#***********************************************************************
# Global CMakeLists.txt file for building OpenMolcas with CMake.
#
# Steven Vancoillie - Spring 2014, on a Saturday afternoon, with coffee
# Ignacio Fdez. Galván made several improvements / additions
# Gerardo Raggi - AppleClang

cmake_minimum_required (VERSION 3.12)
cmake_policy (VERSION 3.12...3.13)

project (OpenMolcas
         LANGUAGES Fortran C
         VERSION ""
)

#set (CMAKE_VERBOSE_MAKEFILE ON)

include (${PROJECT_SOURCE_DIR}/cmake/cmake_helpers.cmake)

# Prevent in-source builds
# If an in-source build is attempted, you will still need to clean up a few files manually.
set (CMAKE_DISABLE_SOURCE_CHANGES ON)
set (CMAKE_DISABLE_IN_SOURCE_BUILD ON)
get_filename_component (sourcedir "${CMAKE_SOURCE_DIR}" REALPATH)
get_filename_component (binarydir "${CMAKE_BINARY_DIR}" REALPATH)
if ("${sourcedir}" STREQUAL "${binarydir}")
  message (FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "
          "allowed, please remove ./CMakeCache.txt and ./CMakeFiles/, create a "
          "separate build directory and run cmake from there.")
endif ()

# discover some necessary tools
find_program (GIT "git")
find_program (PERL "perl")
mark_as_advanced (FORCE GIT PERL)

FIND_PACKAGE (PythonInterp 3.0)
if (NOT PYTHONINTERP_FOUND)
  FIND_PACKAGE (PythonInterp 2.7)
endif ()

################################################################################
#                                                                              #
# Options                                                                      #
#                                                                              #
################################################################################

# The build type, specifies the different optimization types.
if (NOT DEFINED CMAKE_BUILD_TYPE OR "${CMAKE_BUILD_TYPE}" STREQUAL "")
  set (CMAKE_BUILD_TYPE "Release" CACHE STRING
       "Type of build, options are: None (CFLAGS/FFLAGS can be used), Debug, Garble, RelWithDebInfo, Release, Fast."
       FORCE)
endif ()
set_property (CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS None Debug Garble RelWithDebInfo Release Fast)

# The place where OpenMolcas is installed with make install.
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set (CMAKE_INSTALL_PREFIX "/opt/OpenMolcas" CACHE PATH "Location where OpenMolcas will be installed." FORCE)
endif ()
set (EXTRA_INSTALL_TARGETS "")
set (EXTRA_INSTALL_DIRS "")
set (EXTRA_INSTALL_IMPORTED_LIBS "")

option (INSTALL_TESTS "Install the test files and verify script." OFF)

set (DEBUG_DEFS "${DEBUG_DEFS}" CACHE STRING "Additional user-supplied definitions.")
separate_arguments (DEBUG_DEFS)

option (BUILD_SHARED_LIBS "Build dynamically-linked libraries." OFF)
option (BUILD_STATIC_LIBS "Build statically-linked libraries too." OFF)
if (BUILD_SHARED_LIBS)
  mark_as_advanced (CLEAR BUILD_STATIC_LIBS)
else ()
  mark_as_advanced (FORCE BUILD_STATIC_LIBS)
endif ()

option (MPI "Enable MPI parallellization." OFF)
option (GA "Use Global Arrays library." OFF)

option (OPENMP "Enable multi-threading." OFF)
option (IPO "Enable interprocedural optimization (if supported)." OFF)

option (BOUNDS "Enable bounds checking (only GNU Fortran)." OFF)

option (EXPERT "Show advanced compiler flags in CMake GUI)." OFF)

option (BIGOT "Do not allow any compiler warning (treat them as errors)." OFF)

set (LINALG_OPTIONS "Choose linear algebra library, options: Internal (default), Runtime, MKL, OpenBLAS, AOCL, Accelerate, Manual.")
if (DEFINED LINALG)
  set (LINALG "${LINALG}" CACHE STRING "${LINALG_OPTIONS}")
  if (NOT ";Internal;Runtime;MKL;OpenBLAS;AOCL;Accelerate;Manual;" MATCHES ";${LINALG};")
      message (FATAL_ERROR "Unsuported LINALG: ${LINALG}")
  endif ()
else ()
  set (LINALG "Internal" CACHE STRING "${LINALG_OPTIONS}")
endif ()
set_property (CACHE LINALG PROPERTY STRINGS Internal Runtime MKL OpenBLAS AOCL Accelerate Manual)

option (CUBLAS "Enable CUDA BLAS library." OFF)
option (NVBLAS "Enable NVidia BLAS library." OFF)

option (FDE "Enable Frozen-density-embedding (FDE) interface." OFF)
option (GROMACS "Compile Gromacs interface." OFF)
option (BLOCK "Activate BLOCK-DMRG support." OFF)
option (CHEMPS2 "Activate CheMPS2-DMRG support." OFF)

option (GPERFTOOLS "Activate gperftools CPU profiling." OFF)
option (GCOV "Activate code coverage profiling (use with Debug/-O0)." OFF)
option (HDF5 "Activate HDF5 support for wavefunction format." ON)

option (TOOLS "Compile supported tools." OFF)

option (BUILD_TESTING "Build the unit_tests." ON)

if (";Debug;Garble;" MATCHES ";${CMAKE_BUILD_TYPE};")
  add_compile_definitions (_ADDITIONAL_RUNTIME_CHECK_)
endif ()

if (";Debug;Garble;RelWithDebInfo;" MATCHES ";${CMAKE_BUILD_TYPE};" OR
    CMAKE_Fortran_COMPILER_ID STREQUAL "NAG" OR
    BIGOT)
  add_compile_definitions (_WARNING_WORKAROUND_)
endif ()

# External projects
option (DMRG     "Activate QCMaquis DMRG driver and library."                                                 OFF)
option (EFPLIB   "Enable EFPLib library for effective fragment potentials (requires External/efp submodule)." OFF)
option (GA_BUILD "Build Global Arrays."                                                                       OFF)
option (GEN1INT  "Enable Gen1Int library for 1-electron integrals."                                           OFF)
option (MolGUI   "Enable the Molcas Graphical User Interface."                                                OFF)
option (MSYM     "Activate MSYM support (requires External/libmsym submodule)."                               OFF)
option (NECI     "Activate NECI support (requires External/NECI submodule)."                                  OFF)
option (NEVPT2   "Activate (DMRG)-NEVPT2 support."                                                            OFF)
option (WFA      "Activate extended wavefunction analysis (requires External/libwfa submodule)."              OFF)

################################################################################
#                                                                              #
# Global settings                                                              #
#                                                                              #
################################################################################

# mark that we are running CMake (for subprocesses)
set (ENV{CMAKE_SESSION} "OpenMolcas")

# project name and supported languages
#=====================================
message ("Configuring compilers:")

if (WFA OR MolGUI OR DMRG)
  enable_language (CXX)
endif ()

#avoid using CXX compiler for linking
set (CMAKE_CXX_LINKER_PREFERENCE_PROPAGATES "FALSE")

add_compile_definitions (_MOLCAS_)

#set cmake module search paths
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH})

# location of molcas-extra
if (NOT DEFINED EXTRA)
  if (DEFINED ENV{EXTRA})
    set (EXTRA $ENV{EXTRA})
  else ()
    set (EXTRA "")
  endif ()
endif ()
if (NOT "${EXTRA}" STREQUAL "")
  if (NOT IS_ABSOLUTE "${EXTRA}")
    set (EXTRA "${PROJECT_BINARY_DIR}/${EXTRA}")
  endif ()
  get_filename_component (EXTRA "${EXTRA}" ABSOLUTE)
  if (NOT EXISTS "${EXTRA}")
    message (WARNING "The molcas-extra directory ${EXTRA} does not exist.")
  else ()
    FILE (STRINGS "${EXTRA}/.molcashome" DIR_TYPE)
    if ("${DIR_TYPE}" STREQUAL "molcas-extra")
      set (EXTRA_DIR ${EXTRA})
      add_compile_definitions (_HAVE_EXTRA_)
    else ()
      message (FATAL_ERROR "The directory ${EXTRA} does not contain molcas-extra.")
    endif ()
  endif ()
endif ()
set (EXTRA "${EXTRA}" CACHE PATH "Location of the molcas-extra directory." FORCE)

# possible locations for source code
set (OPENMOLCAS_DIR ${CMAKE_CURRENT_LIST_DIR})
if (NOT ${PROJECT_SOURCE_DIR} STREQUAL ${OPENMOLCAS_DIR})
  set (basedirs ${PROJECT_SOURCE_DIR})
  set (EXTRA_DIR ${PROJECT_SOURCE_DIR})
  add_compile_definitions (_HAVE_EXTRA_)
endif ()
list (APPEND basedirs ${OPENMOLCAS_DIR})
if (NOT "${EXTRA}" STREQUAL "")
  if (NOT ";${basedirs};" MATCHES ";${EXTRA};")
    list (APPEND basedirs ${EXTRA})
  endif ()
endif ()
foreach (BASE_DIR ${basedirs})
  file (GLOB source_roots_tmp RELATIVE ${PROJECT_SOURCE_DIR} "${BASE_DIR}/src*")
  list (SORT source_roots_tmp)
  list (APPEND source_roots ${source_roots_tmp})
endforeach ()
list (REVERSE basedirs)

# get version from git if available, otherwise look in .molcasversion
#====================================================================

message ("Detecting Molcas version info:")

set (ENV{MOLCAS} ${PROJECT_BINARY_DIR})
set (ENV{OPENMOLCAS} ${OPENMOLCAS_DIR})
if (DEFINED EXTRA_DIR)
  set (ENV{MOLCAS_SOURCE} ${EXTRA_DIR})
else ()
  set (ENV{MOLCAS_SOURCE} ${OPENMOLCAS_DIR})
endif ()

execute_process (
  COMMAND ${GIT} "rev-parse" "--git-dir"
  WORKING_DIRECTORY ${OPENMOLCAS_DIR}
  OUTPUT_VARIABLE GIT_REVPARSE_OUTPUT
  ERROR_VARIABLE GIT_REVPARSE_ERROR
  RESULT_VARIABLE GIT_REVPARSE_RC
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
if (GIT_REVPARSE_RC)
  set (OPENMOLCAS_GIT_REPO "${OPENMOLCAS_DIR}/.git")
else ()
  set (OPENMOLCAS_GIT_REPO "${GIT_REVPARSE_OUTPUT}")
  if (NOT IS_ABSOLUTE "${OPENMOLCAS_GIT_REPO}")
    set (OPENMOLCAS_GIT_REPO "${OPENMOLCAS_DIR}/${OPENMOLCAS_GIT_REPO}")
  endif ()
endif ()
set (MOLCAS_VERSION_FILE "${PROJECT_SOURCE_DIR}/.molcasversion")

if (DEFINED EXTRA_DIR)
  execute_process (
    COMMAND ${GIT} "rev-parse" "--git-dir"
    WORKING_DIRECTORY ${EXTRA_DIR}
    OUTPUT_VARIABLE GIT_REVPARSE_OUTPUT
    ERROR_VARIABLE GIT_REVPARSE_ERROR
    RESULT_VARIABLE GIT_REVPARSE_RC
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  if (GIT_REVPARSE_RC)
    set (EXTRA_GIT_REPO "${EXTRA_DIR}/.git")
  else ()
    set (EXTRA_GIT_REPO "${GIT_REVPARSE_OUTPUT}")
    if (NOT IS_ABSOLUTE "${EXTRA_GIT_REPO}")
      set (EXTRA_GIT_REPO "${EXTRA_DIR}/${EXTRA_GIT_REPO}")
    endif ()
  endif ()
endif ()

if (EXISTS ${GIT})
  foreach (BASE_DIR ${basedirs})
    if ("${BASE_DIR}" STREQUAL "${OPENMOLCAS_DIR}")
      if (EXISTS ${OPENMOLCAS_GIT_REPO})
        set (MOLCAS_GIT_REPO ${OPENMOLCAS_GIT_REPO})
      else ()
        continue ()
      endif ()
      set (label "")
    elseif ("${BASE_DIR}" STREQUAL "${EXTRA_DIR}")
      if (EXISTS ${EXTRA_GIT_REPO})
        set (MOLCAS_GIT_REPO ${EXTRA_GIT_REPO})
      else ()
        continue ()
      endif ()
      set (label "-extra")
    endif ()
    # always set the HEAD as a source for configuring
    configure_file ("${MOLCAS_GIT_REPO}/HEAD" git-head${label} COPYONLY)
    # if it is a ref to a named branch, include the branch ref too
    file (READ "${MOLCAS_GIT_REPO}/HEAD" HEAD_STRING)
    string (STRIP "${HEAD_STRING}" HEAD_STRING)
    string (REPLACE "ref: " "" HEAD_REF "${HEAD_STRING}")
    if (EXISTS "${MOLCAS_GIT_REPO}/${HEAD_REF}")
      configure_file ("${MOLCAS_GIT_REPO}/${HEAD_REF}" git-head-ref${label} COPYONLY)
    endif ()
    # now, get the actual versions from the git describe tool
    execute_process (

=== unit_tests/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2020, Oskar Weser                                      *
#***********************************************************************

include_guard(GLOBAL)

include(${PROJECT_SOURCE_DIR}/cmake/cmake_helpers.cmake)

# unsupported compilers
set(not_supported ";SunPro;PGI;")

set(UNIT_TEST_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

set(all_tests "")

function(add_unit_test Target)
    add_directory(../fruit_molcas)

    add_executable(${Target} ${ARGN})

    target_link_libraries(${Target} fruit_molcas libmolcas ${EXTERNAL_LIBRARIES})

    set_target_properties(${Target}
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY
            "${UNIT_TEST_BUILD_DIR}/bin")

    add_test(
        NAME
            ${Target}
        COMMAND
            $<TARGET_FILE:${Target}>)

    list(APPEND all_tests ${Target})
    set(all_tests ${all_tests} PARENT_SCOPE)

    set_tests_properties(
        ${Target}
        PROPERTIES
            ENVIRONMENT "MOLCAS_MEM=256"
            FIXTURES_REQUIRED "test_fixture")
endfunction()

macro(add_test_directory SubDir)
    add_subdirectory(${SubDir}/)
    get_directory_property(all_tests DIRECTORY ${SubDir} DEFINITION all_tests)
endmacro()

# start adding tests, but don't bother with shitty compilers
if (NOT ((CMAKE_Fortran_COMPILER_ID IN_LIST not_supported) OR (CMAKE_Fortran_COMPILER_ID STREQUAL "Intel" AND CMAKE_Fortran_COMPILER_VERSION VERSION_LESS "14")))
    add_test_directory(linalg_mod/)
    add_test_directory(fortran_strings/)
    add_test_directory(sorting/)

    add_custom_target(build_tests)
    add_dependencies(build_tests ${all_tests})

    add_test(test_build
        "${CMAKE_COMMAND}"
        --build "${CMAKE_BINARY_DIR}"
        --config "$<CONFIG>"
        --target build_tests
    )

    set_tests_properties(
        test_build
        PROPERTIES
            FIXTURES_REQUIRED "test_fixture")
endif()

=== Tools/dynamixtools/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2015,2016,2019,2020, Ignacio Fdez. Galván              *
#***********************************************************************
if (NOT DEFINED BASE_DIR)
  set (BASE_DIR ${PROJECT_SOURCE_DIR})
endif ()
file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
set (EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/${tooldir})

if (PYTHONINTERP_FOUND)

  foreach (prog IN ITEMS dynamixtools)
    file (READ ${CMAKE_CURRENT_LIST_DIR}/${prog}.py content)
    file (WRITE ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${prog}.py "#!/usr/bin/env ${PYTHON_EXECUTABLE}\n")
    file (APPEND ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${prog}.py "${content}")
    file (COPY ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${prog}.py
          DESTINATION ${EXECUTABLE_OUTPUT_PATH}
          FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
    )
    install (PROGRAMS
             ${EXECUTABLE_OUTPUT_PATH}/${prog}.py
             DESTINATION ${CMAKE_INSTALL_PREFIX}/${tooldir}
    )
  endforeach (prog)

else ()

  message (WARNING "No appropriate python interpreter found, dynamixtools will be disabled")

endif ()

=== Tools/pymolcas/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2017,2020, Ignacio Fdez. Galván                        *
#***********************************************************************
if (NOT DEFINED BASE_DIR)
  set (BASE_DIR ${PROJECT_SOURCE_DIR})
endif ()
file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
set (OUTPUT_PATH ${PROJECT_BINARY_DIR}/)

file (GLOB py_sources "*.py")
list (REMOVE_ITEM py_sources "${CMAKE_CURRENT_LIST_DIR}/pack.py")

if (NOT PYTHONINTERP_FOUND)
  set (dir_error "disabled (no appropriate python interpreter found)" PARENT_SCOPE)
  return ()
endif ()

set (PYTHONINTERP_FOUND "${PYTHONINTERP_FOUND}" PARENT_SCOPE)

execute_process (COMMAND ${PYTHON_EXECUTABLE} imports.py
                 WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
                 OUTPUT_VARIABLE PYMOLCAS_IMPORT_OUTPUT
                 RESULT_VARIABLE PYMOLCAS_IMPORT_RC
                 OUTPUT_STRIP_TRAILING_WHITESPACE
)

if (PYMOLCAS_IMPORT_RC)
  message (WARNING "Some python modules are not available: ${PYMOLCAS_IMPORT_OUTPUT}")
  set (dir_error "disabled" PARENT_SCOPE)
  return ()
endif ()

set (PYMOLCAS_SCRIPT "${OUTPUT_PATH}/pymolcas")
set (PYMOLCAS_SCRIPT "${PYMOLCAS_SCRIPT}" PARENT_SCOPE)

# Note the command and the target must have different names
add_custom_command (OUTPUT ${PYMOLCAS_SCRIPT}
                    COMMAND ${PYTHON_EXECUTABLE} export.py ${PYMOLCAS_SCRIPT}
                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
                    DEPENDS ${py_sources}
)

add_custom_target (pymolcas_target ALL
                   DEPENDS ${PYMOLCAS_SCRIPT}
)

=== src/alaska/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     main.F90
     alaska_banner.F90
     alaska.F90
     alaska_info.F90
     alaska_super_driver.F90
     annihil_rho.F90
     chk_numerical.F90
     cho_alaska_rdinp.F90
     drvdftg.F90
     drvemb_.F90
     drvembg.F90
     drvg1.F90
     drvh1_emb.F90
     drvn1_emb.F90
     drvn1.F90
     inputg.F90
)

include (${PROJECT_SOURCE_DIR}/cmake/prog_template.cmake)

=== src/chemps2_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     chemps2ctl.F90
     chemps2_densi_rasscf.F90
     chemps2_load2pdm.F90
     chemps2_load3pdm.F90
     fcidump_output.F90
     irreps.F90
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list "")

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== src/expbas/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     main.F90
     desym.F90
     driverbas.F90
     expandbas.F90
     expbas.F90
     info_expbas.F90
     readinp_expbas.F90
)

include (${PROJECT_SOURCE_DIR}/cmake/prog_template.cmake)

=== src/hdf5_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     mh5_capi.c
     mh5.F90
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list
     mh5.F90
)

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== src/io_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     aixcheck.F90
     aixcls.F90
     aixerr.c
     aixfsz.F90
     aixmv.F90
     aixopn.F90
     aixprd.F90
     aixpwr.F90
     aixrd.F90
     aixrm.F90
     aixwr.F90
     allocdisk.c
     append_file.F90
     append_file_u.F90
     bdafile.F90
     cdafile.F90
     chdafile.F90
     cio.c
     daclos.F90
     daeras.F90
     dafile_checkarg.F90
     dafile.F90
     daname.F90
     daname_main.F90
     daname_mf.F90
     daname_mf_wa.F90
     daname_wa.F90
     ddafile.F90
     f_inquire.F90
     fast_io.F90
     fastio.F90
     fcopy.F90
     filesystem_wrapper.c
     find_lu.F90
     fioinit.F90
     fscb2unit.F90
     get_mbl_wa.F90
     handle2name.F90
     idafile.F90
     isfreeunit.F90
     is_opened.F90
     lu2desc.F90
     lu2handle.F90
     molcas_binaryopen_vanilla.F90
     molcas_open_ext.F90
     molcas_open.F90
     mpdafile.F90
     next_non_comment.F90
     prgm.F90
     prgminit.F90
     prgmtranslatec.F90
     prgmtranslate.F90
     prgmtranslate_master.F90
     zip.c
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list
     prgm.F90
)

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== src/linalg_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     blockdiagonal_matrices.F90
     dgeadd.F90
     dgesub.F90
     dgetmi.F90
     dgetmo.F90
     dnaxpy.F90
     dndot.F90
     dtrans.F90
     dyax.F90
     dzaxpy.F90
     eigen_molcas.F90
     fzero.F90
     idmin.F90
     ilasrt.F90
     index_util.F90
     izero.F90
     linalg_mod.F90
     matinvert.F90
     nidiag.F90
     nidiag_new.F90
     not_dgeev.F90
     scatter.F90
     vecphase.F90
     xeigen.F90
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list
     blockdiagonal_matrices.F90
     index_util.F90
     linalg_mod.F90
)

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== src/molcas_ci_util/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     chksplit.F90
     cidia_ci_util.F90
     ciovlp.F90
     ciselect.F90
     citrans.F90
     citrans_free.F90
     citrans_init.F90
     cndet.F90
     cnfstr.F90
     cnhcn.F90
     csdiag_ci_util.F90
     csdtvc.F90
     cstart_ci_util.F90
     davctl.F90
     davctl_mod.F90
     david5.F90
     detstr2.F90
     dgmm2_molcas.F90
     diagord.F90
     dihdj_molcas.F90
     expcsf.F90
     explh2.F90
     faroald.F90
     faroald_free.F90
     faroald_init.F90
     fndmnx.F90
     gatvcs.F90
     get_cm_.F90
     get_cm.F90
     getcnf_lucia.F90
     geth2a.F90
     getstepvector.F90
     get_umn.F90
     hcsce.F90
     ini_david.F90
     init_lex.F90
     ipcsfsplit.F90
     iphase.F90
     isgnum.F90
     lex_iter.F90
     load_ci_vec.F90
     load_h_diag.F90
     load_sig_vec.F90
     load_tmp_ci_vec.F90
     load_tmp_sig_vec.F90
     lucia2molcas.F90
     lucia2molcas_free.F90
     matml4.F90
     mkclist.F90
     motrac.F90
     newgs.F90
     ordstr.F90
     page_in.F90
     pageno.F90
     page_out.F90
     phpcsf.F90
     recno.F90
     reord2.F90
     save_ci_vec.F90
     save_h_diag.F90
     save_sig_vec.F90
     save_tmp_ci_vec.F90
     save_tmp_sig_vec.F90
     scavcs.F90
     schmidt.F90
     second_quantization.F90
     sigmadet_cvb.F90
     simplify.F90
     sort_cdet.F90
     splitctl.F90
     stepvec.F90
     stepvector_next.F90
     term_david.F90
     transadd.F90
)

# Source files defining modules that should be available to other *_util directories
set (modfile_list "")

include (${PROJECT_SOURCE_DIR}/cmake/util_template.cmake)

=== src/mpprop/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

set (sources
     main.F90
     gen_prim_density_matrix.F90
     get_density_matrix.F90
     get_mpprop.F90
     get_mpprop_input.F90
     get_ocof.F90
     get_orbcen.F90
     get_orbe.F90
     get_polar.F90
     get_prim_atom_tab.F90
     get_prim_density_matrix.F90
     laurapol.F90
     mpprop.F90
     mpprop_globals.F90
     noverp.F90
     storempaslop.F90
     wr_cord.F90
     wr_files.F90
     wr_mpprop.F90
     wr_prop.F90
)

include (${PROJECT_SOURCE_DIR}/cmake/prog_template.cmake)

=== debian/changelog ===
openmolcas (21.10-1ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/tests/testsuite.sh: make the testsuite resilient in the face of
      parent directory not being writable.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 03 Jan 2022 16:37:44 -0800

openmolcas (21.10-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/mkl_library_dir.patch: Refreshed.
  * debian/patches/pymolcas_default_directories.patch: Likewise.
  * debian/patches/install_locations.patch: Likewise.
  * debian/patches/openblas_hardcode_includedir.patch: Likewise.
  * debian/patches/linux_platform_support.patch: Likewise.
  * debian/patches/verify_default_directories.patch: Rewritten.
  * debian/openmolcas.install: Remove .plx files, they are no longer present.
  * debian/rules (override_dh_auto_build): Target removed, no longer needed.
  * debian/rules (override_dh_auto_install): No longer install pymolcas_, file
    no longer exists.

 -- Michael Banck <mbanck@debian.org>  Mon, 03 Jan 2022 00:48:27 +0100

openmolcas (20.10-2ubuntu1) impish; urgency=medium

  * debian/tests/testsuite.sh: make the testsuite resilient in the face of
    parent directory not being writable.  Thanks to Dan Bungert
    <daniel.bungert@canonical.com>.  Closes: #988161, LP: #1932202.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 28 Aug 2021 13:42:38 -0700

=== debian/control ===
Source: openmolcas
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>= 10),
               cmake (>= 3.0.2),
               gfortran,
               libopenblas64-openmp-dev,
               libjs-jquery,
               libjs-underscore,
               python3-pyparsing,
               python3-six,
               python3-sphinx,
               python3-sphinxcontrib.bibtex
Standards-Version: 4.1.3
X-Python3-Version: >= 3.6
Homepage: https://gitlab.com/Molcas/OpenMolcas
Testsuite: autopkgtest-pkg-python
Vcs-Browser: https://salsa.debian.org/debichem-team/openmolcas
Vcs-Git: https://salsa.debian.org/debichem-team/openmolcas.git

Package: openmolcas
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         openmolcas-data (= ${source:Version}),
         python3,
         python3-pyparsing,
         python3-six
Description: Quantum chemistry software package
 The key feature of OpenMolcas is the multiconfigurational approach to the
 electronic structure.
 .
 It can compute energies, gradients and hessians for the following methods:
  * Hartree-Fock SCF (HF)
  * Complete active space SCF (CASSCF)
 .
 It can compute energies and gradients for the following methods:
  * Hartree-Fock (HF)
  * Density-Functional Theory (DFT)
  * Second-order Moeller-Plesset perturbation theory (MP2)
  * Complete and restricted active space SCF (CASSCF/RASSCF)
 .
 Additionally, it can compute energies for the following methods:
  * Closed shell Moeller-Plesset perturbation theory (MP2)
  * Complete active space second order perturbation theory (CASPT2)
  * Coupled-cluster singles doubles (CCSD), optionally wihth
    Cholesky-Decomposition (CD)/Resolution-of-the Identity (RI)
  * CD/RI Coupled-cluster singles doubles with perturbative
    triples (CCSD(T))
  * Density Matrix Renormalization Group SCF (DMRG-SCF)

Package: openmolcas-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Quantum chemistry software package (data files)
 The key feature of OpenMolcas is the multiconfigurational approach to the
 electronic structure.
 .
 This package contains data files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export FFLAGS=$(shell dpkg-buildflags --get FFLAGS) -fno-expensive-optimizations

%:
	dh $@ --buildsystem=cmake --with sphinxdoc

override_dh_auto_configure:
	dh_auto_configure --		\
		-DTOOLS=ON		\
		-DOPENMP=ON		\
		-DLINALG=OpenBLAS	\
		-DOPENBLASROOT=/usr/include/${DEB_HOST_MULTIARCH}/openblas64-openmp \
		-DCMAKE_SKIP_RPATH=ON

override_dh_auto_install:
	dh_auto_install
	cp -a test debian/tmp/usr/share/openmolcas

## openmolcas 22.02

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 # Gerardo Raggi - AppleClang
 
 cmake_minimum_required (VERSION 3.12)
-cmake_policy (VERSION 3.12...3.13)
+cmake_policy (VERSION 3.12...3.21)
 
 project (OpenMolcas
          LANGUAGES Fortran C
@@ -48,10 +48,7 @@
 find_program (PERL "perl")
 mark_as_advanced (FORCE GIT PERL)
 
-FIND_PACKAGE (PythonInterp 3.0)
-if (NOT PYTHONINTERP_FOUND)
-  FIND_PACKAGE (PythonInterp 2.7)
-endif ()
+FIND_PACKAGE (Python COMPONENTS Interpreter)
 
 ################################################################################
 #                                                                              #
@@ -113,6 +110,8 @@
 
 option (CUBLAS "Enable CUDA BLAS library." OFF)
 option (NVBLAS "Enable NVidia BLAS library." OFF)
+
+set (EXTERNAL_LIBXC "" CACHE STRING "Location for an external Libxc build")
 
 option (FDE "Enable Frozen-density-embedding (FDE) interface." OFF)
 option (GROMACS "Compile Gromacs interface." OFF)

=== src/io_util/CMakeLists.txt ===
--- 
+++ 
@@ -48,13 +48,14 @@
      fscb2unit.F90
      get_mbl_wa.F90
      handle2name.F90
+     i1dafile.F90
      idafile.F90
      isfreeunit.F90
      is_opened.F90
      lu2desc.F90
      lu2handle.F90
      molcas_binaryopen_vanilla.F90
-     molcas_open_ext.F90
+     molcas_open_ext2.F90
      molcas_open.F90
      mpdafile.F90
      next_non_comment.F90

=== src/linalg_util/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
      dyax.F90
      dzaxpy.F90
      eigen_molcas.F90
+     exp_schur.F90
      fzero.F90
      idmin.F90
      ilasrt.F90
@@ -32,6 +33,7 @@
      nidiag_new.F90
      not_dgeev.F90
      scatter.F90
+     schur_skew.F90
      vecphase.F90
      xeigen.F90
 )

=== debian/changelog ===
openmolcas (22.02-6) unstable; urgency=medium

  * debian/rules (FFLAGS): Replaced -fno-expensive-optimizations with
    -ffp-contract=off (Closes: #1005202).

 -- Michael Banck <mbanck@debian.org>  Sat, 11 Jun 2022 18:41:44 +0200

openmolcas (22.02-5) unstable; urgency=medium

  * debian/control (Build-Depends): Added libhdf5-dev.
  * debian/rules (dh_override_auto_configure): Enable HDF5 support (Closes:
    #1012591).
  * debian/tests/testsuite.sh: Add HDF5 test.

 -- Michael Banck <mbanck@debian.org>  Fri, 10 Jun 2022 21:43:08 +0200

openmolcas (22.02-4) unstable; urgency=medium

  * Reupload, the last upload accidently disabled the fix_libxc_interface.patch
    patch.

 -- Michael Banck <mbanck@debian.org>  Mon, 04 Apr 2022 18:29:38 +0200

openmolcas (22.02-3) unstable; urgency=medium

  [ Dan Bungert ]
  * debian/tests/testsuite.sh: Apply merge request #1 (Closes: #988161).
    + Fix for when the parent directory can't be written to - use a tempdir
      instead, and clean it up when we're done.
    + Fix basename usage - it can't be handed multiple files at a time, so call
      it once per loop. This can occur if there were multiple test failures.

 -- Michael Banck <mbanck@debian.org>  Sun, 03 Apr 2022 13:38:36 +0200

openmolcas (22.02-2) unstable; urgency=medium

  * debian/control (Depends): Added python3-lxml (for pymolcas verify).
  * debian/rules (override_dh_auto_configure): Set LINALG to "Manual" and
    replace OPENBLASROOT with LINALG_LIBRARIES.
  * debian/patches/openblas_hardcode_includedir.patch: Removed, no longer
    needed. 
  * debian/openmolcas.install: Add help_func. 
  * debian/patches/python_interpreter.patch: New patch, partially reverts
    upstream commit 523c2ef so that pymolcas shebang line does encode the
    python version.
  * debian/patches/fix_libxc_interface.patch: New patch, avoids an assertion
    error when OpenMolcas is linked against a system libxc library with
    assertions on.

 -- Michael Banck <mbanck@debian.org>  Fri, 01 Apr 2022 18:37:53 +0200

openmolcas (22.02-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/mkl_library_dir.patch: Refreshed.
  * debian/patches/install_locations.patch: Likewise.
  * debian/patches/openblas_hardcode_includedir.patch: Likewise.
  * debian/patches/linux_platform_support.patch: Likewise.
  * debian/control (Build-Depends): Added libxc-dev.
  * debian/patches/libxc_hardcode_includedir.patch: New patch, fix the cmake
    libxc detection to look in the multiarch library directory.
  * debian/rules (override_dh_auto_configure): Add EXTERNAL_LIBXC define, set
    to the multiarch library directory.

 -- Michael Banck <mbanck@debian.org>  Sat, 12 Mar 2022 20:15:47 +0100
